    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame} \frametitle{Object Orientated Programming (OOP)}
    
\begin{itemize}[<+->]
    \item focus on 'objects'
    \item objects contain the data and methods acting on them
    \item objects interact with other objects
    \item objects are instances of classes
    \item idea: hide internals of an object from the outside world
    \item Examples: C++, Java, Python, R, modern Fortran, ...
\end{itemize}

\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame} \frametitle{Object Orientated Programming (OOP) in a nutshell}
    \small
    \begin{description}[<+->]
        \item[class] 'compound data type' with data specific methods
        \item[object] A concrete instance of an class that has properties and methods
        \item[encapsulation] Bundles data and methods that operate on the data,\\
                             hiding internal complexities.
        \item[inheritance] Classes can be constructed from a parent, adding or modifying properties or methods
        \item[polymorphism] Ability of objects to take on different forms. Allows one interface to be used for a general class of actions.
    \end{description}

\end{frame}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame} \frametitle{Object Orientated Programming (OOP): Encapsulation}

\begin{itemize}[<+->]
    \item Data and also methods can be 'private'
    \item Access through well defined interface
    \item Internals can be changed without affecting the rest of the code
\end{itemize}

\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame} \frametitle{Object Orientated Programming (OOP): Inheritance}

    \begin{itemize}[<+->]
        \item Derive new classes from existing ones, extending their functionality
        \item Example:
        \begin{itemize}
            \item Parent: classical particle: 
            \begin{itemize}
                \item data: mass, position, velocity
                \item methods: accelerate(Force, dt)
            \end{itemize}
            \item Child: charged classical particle: only add charge, keep the others
        \end{itemize}
        \item Abstract class: 
        \begin{itemize} 
            \item cannot be instantiated
            \item can define methods
            \item can declare virtual methods (prescribe API)
        \end{itemize}
        \item Multiple inheritance: inherit from several parent classes. \\
        (not in Fortran)
    \end{itemize}
    
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame} \frametitle{Object Orientated Programming (OOP): Polymorphism}

\begin{itemize}[<+->]
    \item Same method can execute different behaviour with fixed API
    \item Child classes can override methods of parent
    \item Routines/functions can accept parent or child classes as arguments
    \item Examples: Systems, Multi\_systems
    \item More details later in "Guided Tour"
\end{itemize}
    
\end{frame}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame} \frametitle{Object Orientated Programming (OOP): Constructors/Destructors}

    \begin{itemize}[<+->]
        \item Constructor: Creating an object
        \begin{itemize}
            \item Create memory
            \item Initialize variables
            \item Possible custom code, e.g. debug output
        \end{itemize}
        \item Destructor: Delete an Object
        \begin{itemize}
            \item Possible custom code: e.g. deleting owned objects
            \item free the memory
        \end{itemize}

        \item Default constructors/destructors: often sufficient.
    \end{itemize}
        
\end{frame}
    
    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{frame} \frametitle{Object Orientated Programming (OOP): Templates}

    \begin{itemize}
        \item If various data types support the same methods and operations:
        \item Code can be written without detailed knowledge of the data types
        \item Actual data type is treated as parameter
        \item Specific routines are selected at compile time (faster than runtime polymorphism)
        \item Example: Math library could be written generally for (integer, real, complex, vector types)
        \item Reduces code duplication
        \item In C++: Standard Template Library (STL) now de facto part of language standard.
    \end{itemize}
    
\end{frame}